UNIFDEF(1)

NAME
unifdef - remove ifdef'ed lines

SYNOPSIS
unifdef [-clt] [ -Dsym -Usym -iDsym -iDsym] ... [file]

DESCRIPTION
unifdef is useful for removing ifdef'ed lines from a file while otherwise leaving the file alone. unifdef acts on #ifdef, #ifndef, #else, and #endif lines, and it knows only enough about C to know when one of these is inactive because it is inside a comment, or a single or double quote. Parsing for quotes is very simplistic: when it finds an open quote, it ignores everything (except escaped quotes) until it finds a close quote, and it will not complain if it gets to the end of a line and finds no backslash for continuation.

Available options:
-Dsym
-Usym
    Specify which symbols to define or undefine. and the lines inside those ifdefs will be copied to the output or removed as appropriate. The ifdef, ifndef, else, and endif lines associated with sym will also be removed. Ifdefs involving symbols you don't specify and ``#if'' control lines are untouched and copied out along with their associated ifdef, else, and endif lines. If an ifdef X occurs nested inside another ifdef X, then the inside ifdef is treated as if it were an unrecognized symbol. If the same symbol appears in more than one argument, the last occurrence dominates.

-c  If the -c flag is specified, then the operation of unifdef is complemented, i.e. the lines that would have been removed or blanked are retained and vice versa.

-l  Replace removed lines with blank lines instead of deleting them.
-t  Disables parsing for C comments and quotes, which is useful for plain text.

-iDsym
-iUsym
    Ignore ifdefs. If your C code uses ifdefs to delimit non-C lines, such as comments or code which is under construction, then you must tell unifdef which symbols are used for that purpose so that it won't try to parse for quotes and comments inside those ifdefs. One specifies ignored ifdefs with -iDsym and -iUsym similar to -Dsym and -Usym above.

unifdef copies its output to stdout and will take its input from stdin if no file argument is given.

unifdef works nicely with the -Dsym option added to diff(1) as of the 4.1 Berkeley Software Distribution.

SEE ALSO
diff(1)

DIAGNOSTICS
Inappropriate else or endif.
Premature EOF with line numbers of the unterminated #ifdefs.

Exit status is 0 if output is exact copy of input, 1 if not, 2 if trouble.

BUGS
Should try to deal with ``#if'' lines.

Doesn't work correctly if input contains null characters.

HISTORY
The unifdef command appeared in 4.3BSD.